using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ESRI.ArcGIS.Mobile;
using ESRI.ArcGIS.Mobile.Geometries;
using ESRI.ArcGIS.Mobile.MobileServices;
using ESRI.ArcGIS.Mobile.SdcData;
using ESRI.ArcGIS.Mobile.DataProducts.RasterData;


namespace MobileDesktopApp
{
    public partial class Form1 : Form
    {
      public Form1()
      {
        InitializeComponent();
      }

      private void Form1_Load(object sender, EventArgs e)
      {
          
        try 
        {
          //add mobileserviceconnection + mobilecache components to app
          string thisfolder = System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetCurrentDirectory()).ToString()).ToString()).ToString();
          mobileCache1.StoragePath = thisfolder + "\\MapCache";
          MobileCacheSyncAgent mobileSync = new MobileCacheSyncAgent(mobileCache1, mobileServiceConnection1);
          MobileCacheSyncResults mobileResults = new MobileCacheSyncResults();
          mobileCache1.Open();
          // Uncomment this line if you wish to pull the data from your mobile service
          //      mobileServiceConnection1.CreateCache(mobileCache1.StoragePath, CacheVersion.Version100Beta2);
          map1.DataSources.Add(mobileCache1);
          map1.SetExtent(map1.GetExtent().Resize(0.5));
          //Add the background data
          TileCacheMapLayer tilelayer = new TileCacheMapLayer((thisfolder + "\\Layers"));
          tilelayer.Open();
          map1.MapLayers.Add(tilelayer);
        }
        catch (Exception except)
        {
          throw except;
        }
        //intialize application setup
        map1.ContextMenuStrip = contextMenuStrip1;
          
      }

      private void panToolStripMenuItem_Click(object sender, EventArgs e)
      {
        map1.CurrentMapAction = panMapAction1;
      }

      private void zoomInToolStripMenuItem_Click(object sender, EventArgs e)
      {
        map1.CurrentMapAction = zoomInMapAction1;
      }

      private void zoomOutToolStripMenuItem_Click(object sender, EventArgs e)
      {
        map1.CurrentMapAction = zoomOutMapAction1;
      }
  
      private void identifyToolStripMenuItem_Click(object sender, EventArgs e)
      {
        map1.CurrentMapAction = null;
      }        

      private void map1_MouseDown(object sender, MapMouseEventArgs e)
      {
        //right mouse button used to display the context menu
        if (e.Button == MouseButtons.Right)
          return;
         
        if (map1.CurrentMapAction != null)
          return;

          Cursor.Current = Cursors.WaitCursor;
          MapMouseEventArgs me = e as MapMouseEventArgs;
          Envelope qEnv = new Envelope(me.MapCoordinate, me.MapCoordinate);

          double mapTolerance = map1.ToMap(3);
          qEnv.Resize(mapTolerance, mapTolerance);

          QueryFilter qFilter = new QueryFilter(qEnv, GeometricRelationshipType.Intersect);

          string txtResult = "Identify Results: ";
          int intFields;

    
          foreach (MobileCacheLayer MCLayer in mobileCache1.Layers)
          {
            //Only Feature layers are used in identify 
            if (MCLayer is FeatureLayer) 
            {
              txtResult += "\r\n Layer " + MCLayer.Name;
              FeatureLayer FLayer;
              //cast the MobileServiceLayer to a featureLayer
              FLayer = (FeatureLayer)MCLayer;
              using (FeatureDataReader featReader = FLayer.GetDataReader(qFilter))
              {
                intFields = featReader.FieldCount;
                while (featReader.Read())
                {
                   for (int i = 0; i < intFields; i++)
                     txtResult += "\r\n" + featReader.GetName(i) + ": " + featReader.GetValue(i).ToString();
                }
              }

            }
          }
       
        Cursor.Current = Cursors.Default;
        
        MessageBox.Show(txtResult.ToString());
      }


           

    }
}