' Copyright 2008 ESRI
' 
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
' 
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
' 
' See use restrictions at <your ArcGIS install location>/developerkit/userestrictions.txt.
' 

Imports System.Windows.Forms
Imports ESRI.ArcGIS.Mobile.Geometries
Imports ESRI.ArcGIS.Mobile
Imports ESRI.ArcGIS.Mobile.MobileServices


Public Class Form1


  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MobileCache1.StoragePath = System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetCurrentDirectory()).ToString()).ToString()).ToString() + "\MapCache"
    MobileServiceConnection1.Url = "http://yourserver.domain.com/arcgis/services/YOURSERVICE/mapserver/mobileserver"
    Dim MCSyncAgent As New MobileCacheSyncAgent(MobileCache1, MobileServiceConnection1)

    Try
      MobileCache1.Open()


    Catch
      'What about different error types
      Throw
    End Try
  End Sub


  Private Sub ZoomInToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomInToolStripMenuItem.Click
    Map1.CurrentMapAction = ZoomInMapAction1
  End Sub

  Private Sub PanToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PanToolStripMenuItem.Click
    Map1.CurrentMapAction = PanMapAction1
  End Sub

  Private Sub ZoomOutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomOutToolStripMenuItem.Click
    Map1.CurrentMapAction = ZoomOutMapAction1
  End Sub

  Private Sub IdentifyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IdentifyToolStripMenuItem.Click
    Map1.CurrentMapAction = Nothing
  End Sub

  Private Sub Map1_MouseDown(ByVal sender As System.Object, ByVal e As ESRI.ArcGIS.Mobile.MapMouseEventArgs) Handles Map1.MouseDown
    If (e.Button = Windows.Forms.MouseButtons.Right) Then Exit Sub
    If Not (Map1.CurrentMapAction Is Nothing) Then Exit Sub

    Map1.Cursor = Cursors.WaitCursor
    Dim qEnv As Envelope = New Envelope(e.MapCoordinate, e.MapCoordinate)

    Dim mapTolerance As Integer = Map1.ToMap(3)
    qEnv.Resize(mapTolerance, mapTolerance)

    Dim qFilter As QueryFilter = New QueryFilter(qEnv, GeometricRelationshipType.Intersect)

    Dim txtResult As String = "Identify Results: "

    Dim mclayer As MobileCacheLayer

    For Each mclayer In MobileCache1.Layers
      'Only Feature layers are used in identify 
      If TypeOf (mclayer) Is FeatureLayer Then
        txtResult += vbCrLf + " Layer " + mclayer.Name
        Dim Flayer As FeatureLayer
        Flayer = mclayer
        Dim featReader As FeatureDataReader
        featReader = Flayer.GetDataReader(qFilter)
        Dim intFields As Integer
        intFields = featReader.FieldCount
        While featReader.Read()
          Dim i As Integer
          For i = 0 To intFields - 1 Step i + 1
            txtResult += vbCrLf + featReader.GetName(i) + ": " + featReader.GetValue(i).ToString()
          Next
        End While
        featReader = Nothing

        Flayer = Nothing
      End If
    Next


    Map1.Cursor = Cursors.Default
    MessageBox.Show(txtResult)
    qEnv = Nothing
    qFilter = Nothing

  End Sub


  Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

    Application.Exit()
  End Sub
End Class
